#include <msp430.h> 
#include <stdint.h>

uint8_t buffer[4];
uint8_t* rxPtr;
uint8_t bytesToRead = 0;


#define LOBYTE(x)           (x & 0x00FF)
#define HIBYTE(x)           ((x & 0xFF00) >> 8)


void send8bit(uint8_t data)
{
    while(!( UCB0IFG & UCTXIFG));
        UCB0TXBUF = data;
}

void send16bit(uint16_t data)
{
    while(!( UCB0IFG & UCTXIFG));
            UCB0TXBUF = LOBYTE(data);

    _no_operation();

    while(!( UCB0IFG & UCTXIFG));
            UCB0TXBUF = HIBYTE(data);
}

void read(uint8_t* pBuffer, uint8_t length)
{

    bytesToRead = length;
    UCB0IE |= UCTXIE;

}

void main(void)
{

    WDTCTL = WDTPW + WDTHOLD;
    P3DIR |= BIT0 | BIT3;
    P3SEL|=BIT0+BIT1+BIT2;

    UCB0CTL1 |= UCSWRST;
    UCB0CTL0 = UCCKPH + UCCKPL + UCMST + UCMODE_0 + UCSYNC;
    UCB0CTL1 = UCSSEL_2;
    UCB0CTL1 &=~UCSWRST;
    UCB0IE |= UCRXIE;

    __enable_interrupt();  // Enable interrupts globally


    send8bit(0x2F);  // example how to send a byte

    send16bit(0x6E65);  // example how to send a word (2-byte)

    read(buffer, 4);       // clocks 32 bits (4-bytes) from the slave device

    // go look in buffer for data from slave


    while(1); //sit here and do nothing


}


#pragma vector=USCI_B0_VECTOR
__interrupt void USCI_B0_ISR(void)
{
    switch(__even_in_range(UCB0IV,4))
    {
        case 0:break; // Vector 0 - no interrupt
        case 2: // Vector 2 - RXIFG
            *rxPtr++ = UCB0RXBUF;
            break;

        case 4:
            UCB0TXBUF = 0x00; // dummy bytes
            if(--bytesToRead == 0)
                UCB0IE &= ~UCTXIE;
            break; // Vector 4 - TXIFG
        default: break;
    }
}
